const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Manufacturing_ordersDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const manufacturing_orders = await db.manufacturing_orders.create(
      {
        id: data.id || undefined,

        order_name: data.order_name || null,
        scheduled_date: data.scheduled_date || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await manufacturing_orders.setCompany(data.company || null, {
      transaction,
    });

    await manufacturing_orders.setCompanies(data.companies || null, {
      transaction,
    });

    return manufacturing_orders;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const manufacturing_ordersData = data.map((item, index) => ({
      id: item.id || undefined,

      order_name: item.order_name || null,
      scheduled_date: item.scheduled_date || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const manufacturing_orders = await db.manufacturing_orders.bulkCreate(
      manufacturing_ordersData,
      { transaction },
    );

    // For each item created, replace relation files

    return manufacturing_orders;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const manufacturing_orders = await db.manufacturing_orders.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.order_name !== undefined)
      updatePayload.order_name = data.order_name;

    if (data.scheduled_date !== undefined)
      updatePayload.scheduled_date = data.scheduled_date;

    updatePayload.updatedById = currentUser.id;

    await manufacturing_orders.update(updatePayload, { transaction });

    if (data.company !== undefined) {
      await manufacturing_orders.setCompany(
        data.company,

        { transaction },
      );
    }

    if (data.companies !== undefined) {
      await manufacturing_orders.setCompanies(
        data.companies,

        { transaction },
      );
    }

    return manufacturing_orders;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const manufacturing_orders = await db.manufacturing_orders.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of manufacturing_orders) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of manufacturing_orders) {
        await record.destroy({ transaction });
      }
    });

    return manufacturing_orders;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const manufacturing_orders = await db.manufacturing_orders.findByPk(
      id,
      options,
    );

    await manufacturing_orders.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await manufacturing_orders.destroy({
      transaction,
    });

    return manufacturing_orders;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const manufacturing_orders = await db.manufacturing_orders.findOne(
      { where },
      { transaction },
    );

    if (!manufacturing_orders) {
      return manufacturing_orders;
    }

    const output = manufacturing_orders.get({ plain: true });

    output.company = await manufacturing_orders.getCompany({
      transaction,
    });

    output.companies = await manufacturing_orders.getCompanies({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userCompanies = (user && user.companies?.id) || null;

    if (userCompanies) {
      if (options?.currentUser?.companiesId) {
        where.companiesId = options.currentUser.companiesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.companies,
        as: 'company',
      },

      {
        model: db.companies,
        as: 'companies',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.order_name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'manufacturing_orders',
            'order_name',
            filter.order_name,
          ),
        };
      }

      if (filter.calendarStart && filter.calendarEnd) {
        where = {
          ...where,
          [Op.or]: [
            {
              scheduled_date: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
            {
              scheduled_date: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
          ],
        };
      }

      if (filter.scheduled_dateRange) {
        const [start, end] = filter.scheduled_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            scheduled_date: {
              ...where.scheduled_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            scheduled_date: {
              ...where.scheduled_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.company) {
        const listItems = filter.company.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          companyId: { [Op.or]: listItems },
        };
      }

      if (filter.companies) {
        const listItems = filter.companies.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          companiesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.companiesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.manufacturing_orders.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('manufacturing_orders', 'order_name', query),
        ],
      };
    }

    const records = await db.manufacturing_orders.findAll({
      attributes: ['id', 'order_name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['order_name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.order_name,
    }));
  }
};
